source("invFvMLpower2.R") # version with unitroot
set.seed(666);

p=3;
bvec=c(.5,1,1.4);
nvec=c(100,700);
kappavec=c(1/2,1); # puissances de n à considérer
M=10000;
Mp=10;
L=4; # Number of points in the alternative
tauunit=1; 
alpha=.05;

varphi=function(z,b){
  return(b*(abs(z))^(b-1));
}

theta=c(1,rep(0,p-1));
Proj=diag(p)- theta%*%t(theta);
R=array(0,dim<-c(2,length(bvec),length(nvec),length(kappavec),L+1)); 
Valcrit=qchisq(1-alpha, df=p-1);

Rot=array(0, c(p,p,length(bvec),length(nvec),length(kappavec),L+1))
for (r in (1:length(bvec)))
  {
  for (s in (1:length(nvec)))
      {
      for (t in (1:length(kappavec)))
        {
        b=bvec[r];
        n=nvec[s];
        kappa=n^(kappavec[t]);
        for (ell in 1:(L+1))
          {
          Rot[,,r,s,t,ell]=diag(p);
          angle=2*asin((ell-1)*tauunit/(2*sqrt(n*kappa*varphi(kappa,b))));
          Rot[1:2,1:2,r,s,t,ell]=array( c(cos(angle), sin(angle) ,-sin(angle), cos(angle) ) , dim<-c(2,2) )
          }  
        }
      }
  }

#########################

time=proc.time()
for (m in (1:M))
  {

  for (r in (1:length(bvec)))
    {
    for (s in (1:length(nvec)))
      {
      for (t in (1:length(kappavec)))
        {
        b=bvec[r];
        n=nvec[s];
        kappa=n^(kappavec[t]);
      
        ##################### Data generation
      
        if (isFALSE( ((r==3) && (s==2)) && (t==2) ))
         {
                     
         w=rep(0,n)
          for (i in (1:n)) {w[i]=InvFvML(runif(1),kappa,p,b)}
          X=array(0,dim<-c(n,p));
          X[,1]=w
          Echsub=array(rnorm(n*(p-1)),dim<-c(n,p-1));
          D2=diag(Echsub%*%t(Echsub))
          Echsub=(diag(sqrt(1/D2)))%*%Echsub
          X[,2:p]=diag(sqrt(1-w^2)) %*% Echsub
          Z=X;
          for (ell in (1:(L+1))) 
              {
              X=t(Rot[,,r,s,t,ell]%*%t(Z));
  
              ##################### 
      
              Xbar=apply(X, 2, mean);
              Sphmean=Xbar/sqrt(sum(Xbar^2));
  
              Stand=1-(1/n)*sum((X%*%theta)^2)
              R[1,r,s,t,ell]=R[1,r,s,t,ell]+( ( n*(p-1)/Stand ) * t(Xbar)%*%Proj%*%Xbar > Valcrit);
              R[2,r,s,t,ell]=R[2,r,s,t,ell]+( ( n*(p-1)*(t(Xbar)%*%theta)^2/Stand ) * t(Sphmean)%*%Proj%*%(Sphmean) > Valcrit);
              }
          }
        }
      }
    }
  if (floor(m/Mp)==m/Mp) 
    {
    print(c(m));
    print((proc.time()-time)/m*(M-m)/60);
    }
}
R=R/M;

save.image(file="Fig3.RData")





